/* axpapchap.h
 *
 * Copyright (C) 2001 RedHat, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */
/*
 * Modified for SIKIGAMI 2001,2002 Axe,Inc.
 */

#ifndef __AXPAPCHAP_H__
#define __AXPAPCHAP_H__

#include "axconf.h"

#define PAP_SECRETS	"/etc/ppp/pap-secrets"
#define CHAP_SECRETS	"/etc/ppp/chap-secrets"
#define REMOTE_SECRET	"sgdial"

typedef struct _AxPapChap AxPapChap;

struct _AxPapChap {
	int		pap_success;
	int		chap_success;
	GSList	* contents;
};

extern	void	AxPapChap_init( AxPapChap * );
extern	void	AxPapChap_clear( AxPapChap * );
extern	void	AxPapChap_put_secret( AxPapChap *, char *, char *, char * );
extern	void	AxPapChap_nuke_contents( AxPapChap * );
extern	int		AxPapChap_load_file( AxPapChap *, char * );
extern	int		AxPapChap_write_file( AxPapChap *, char * );
extern	int		AxPapChap_isok_pap( AxPapChap * );
extern	int		AxPapChap_isok_chap( AxPapChap * );
extern	void	AxPapChap_do_secret( AxPapChap *, char *, char *, char * );

#endif
